/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"                      // Include simple tools
#include "propeller.h"

void readModePin(void);
void readDirectionPins(void);

#define westPin          3
#define northPin         4
#define eastPin          7
#define southPin         6
#define modePin          5
#define lowLedPin        24
#define med1LedPin       25
#define med2LedPin       26
#define highLedPin       27
#define rmotorPin        9
#define dmotorPin        11
#define rdirPin          10
#define ddirPin          13

int directionFlag      = 0;
int westPinState       = 0;
int lastwestPinState   = 0;
int northPinState      = 0;
int lastnorthPinState  = 0;
int eastPinState       = 0;
int lasteastPinState   = 0;
int southPinState      = 0;
int lastsouthPinState  = 0;
int currentmodeswitchState = 0;
int lastmodeswitchState = 0;
int mode;
unsigned long currentMillis;
unsigned long lastMillis;


int main()                                    // Main function
{
  clkset(0x6b,5000000);
  low(lowLedPin);                             // Add startup code here.
  low(med1LedPin);
  low(med2LedPin);
  low(highLedPin);
  
  low(rmotorPin);
  low(dmotorPin);
  low(rdirPin);
  low(ddirPin);
  pwm_start(600);
 
  while(1)
  {
    readModePin();                            // Add main loop code here.
    readDirectionPins();
    pause(50);
    
  } 
}
  //                                        readModePin 
  // ***************************************************************************
void readModePin()
 {
   currentmodeswitchState = input(modePin);
   if(currentmodeswitchState != lastmodeswitchState)
    {
      lastmodeswitchState = currentmodeswitchState;
      if(currentmodeswitchState == 0)
       { 
        mode ++;
        if(mode > 4)
         {
           mode = 1;
         }
       }
       else
       {} 
    }
   switch(mode)
   {
     case 1:
       high(lowLedPin);
       low(med1LedPin);
       low(med2LedPin);
       low(highLedPin);
       break;
       
     case 2:
       low(lowLedPin);
       high(med1LedPin);
       low(med2LedPin);
       low(highLedPin);
       break;
       
     case 3:
       low(lowLedPin);
       low(med1LedPin);
       high(med2LedPin);
       low(highLedPin);
       break;   
       
     case 4:
       low(lowLedPin);
       low(med1LedPin);
       low(med2LedPin);
       high(highLedPin);
       break;
       
     default:
       { }
   } 
 }   
  //                           readDirectionalPins
  // *********************************************************************
void readDirectionPins() 
  {  //0 = none, 1 = west, 2 = north, 3 = east, 4 = south, 5 = reset                          
   westPinState = input(westPin);
   if(westPinState != lastwestPinState)
    {
      lastwestPinState = westPinState;
      if(westPinState == 0)
       {
         directionFlag = 1;
         low(rdirPin);
         low(ddirPin);
       }
     else
       {
         directionFlag = 5;
         low(rmotorPin);
         low(dmotorPin);
         low(rdirPin);
         low(ddirPin);
       }
    }
  // ********************************************************
   northPinState = input(northPin);
   if(northPinState != lastnorthPinState)
   {
     lastnorthPinState = northPinState;
     if(northPinState == 0)
     {
       directionFlag = 2;
       low(rdirPin);
       low(ddirPin);
     }
   else
     {
       directionFlag = 5;
       low(rmotorPin);
       low(dmotorPin);
       low(rdirPin);
       low(ddirPin);
     }
  }
  // ************************************
  eastPinState = input(eastPin);
  if(eastPinState != lasteastPinState)
  {
    lasteastPinState = eastPinState;
    if(eastPinState == 0)
    {
      directionFlag = 3;
      high(rdirPin);
      low(ddirPin);
    }
  else
    {
      directionFlag = 5;
      low(rmotorPin);
      low(dmotorPin);
      low(rdirPin);
      low(ddirPin);
    }
 }
  // ********************************************************
    southPinState = input(southPin);
    if(southPinState != lastsouthPinState)
     {
       lastsouthPinState = southPinState;
       if(southPinState == 0)
        { 
         directionFlag = 4;
         low(rdirPin);
         high(ddirPin);
       }
     else
       {
         directionFlag = 5;
         low(rmotorPin);
         low(dmotorPin);
         low(rdirPin);
         low(ddirPin);
       }
    }
   //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
 
   if(directionFlag != 0)
    {
      switch(mode)
       {
         //mode 1
         case 1:
          switch(directionFlag)
           {
             //mode 1
             case 1: 
             {
               pwm_set(rmotorPin,0,235);
               pwm_set(dmotorPin,1,0);
               directionFlag = 0;
             }
              break;
            case 2:
            {
              pwm_set(rmotorPin,0,0);
              pwm_set(dmotorPin,1,175);
              directionFlag = 0;
            }
             break;
            case 3:                                                    
            {
              pwm_set(rmotorPin,0,235);
              pwm_set(dmotorPin,1,0);
              directionFlag = 0; 
            }
             break;
            case 4:
            {
              pwm_set(rmotorPin,0,0);
              pwm_set(dmotorPin,1,175);
              directionFlag = 0;
            }
            break;
        }
          break;
 //++++++++++++
    // mode 2:
    case 2:
     switch(directionFlag)
      {  // mode 2 west
        case 1: 
        {
          pwm_set(rmotorPin,0,375);
          pwm_set(dmotorPin,1,0);
          directionFlag = 0;
        }
          break;
        case 2:
        {
          pwm_set(rmotorPin,0,0);
          pwm_set(dmotorPin,1,290);
          directionFlag = 0;
        }
          break;
        case 3:
        {
          pwm_set(rmotorPin,0,375);
          pwm_set(dmotorPin,1,0);
          directionFlag = 0;
        }
          break;
        case 4:
        {
          pwm_set(rmotorPin,0,0);
          pwm_set(dmotorPin,1,290);
          directionFlag = 0;
        }
          break;
      }
        break;
 //++++++++++++++++++++++++++++++++++++++++++++++++++++++
    // mode  3:
    case 3:
      switch(directionFlag)
       { // mode 3 west
         case 1:
         {
           pwm_set(rmotorPin,0,475);
           pwm_set(dmotorPin,1,0);
           directionFlag = 0;
         } 
           break;
         case 2:
         {
           pwm_set(rmotorPin,0,0);
           pwm_set(dmotorPin,1,400); 
           directionFlag = 0;
         }
           break;
         case 3:
         {
           pwm_set(rmotorPin,0,475);
           pwm_set(dmotorPin,1,0);
           directionFlag = 0;
         }
           break;
         case 4:
         {
           pwm_set(rmotorPin,0,0);
           pwm_set(dmotorPin,1,400);
           directionFlag = 0;
         }
           break;
     }
       break;
 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   // mode 4:
   case 4:
    switch(directionFlag)
    {  // west
       case 1:
       {
         pwm_set(rmotorPin,0,550);
         pwm_set(dmotorPin,1,0);
         directionFlag = 0;
       }  
         break;
       case 2:
       {
         pwm_set(rmotorPin,0,0); 
         pwm_set(dmotorPin,1,475);
         directionFlag = 0;
       }
         break;
       case 3:
       {
         pwm_set(rmotorPin,0,550);
         pwm_set(dmotorPin,1,0);
         directionFlag = 0;
       }
         break;
       case 4:
       {
         pwm_set(rmotorPin,0,0);
         pwm_set(dmotorPin,1,475);
         directionFlag = 0;
       }
         break;
     }
       break;
   }
 //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if(directionFlag == 5)
    {
      directionFlag = 0;
    }
   }
  }     

                                                                                                                        
                                                                                                                                                                                          
  